@echo off
TITLE ZTE Axon 10 Pro EDL Tool (A2020/A2020G/A2020U)
mode con cols=92 lines=40

reg query "HKU\S-1-5-19\Environment" >NUL 2>NUL
if not %ERRORLEVEL% EQU 0 (CLS & ECHO.!!! ERROR !!! You must run the program as administrator! & Pause & Exit)

set part_lun0=\"ssd\" \"persist\" \"cache\" \"misc\" \"keystore\" \"frp\" \"vm-system_a\" \"vm-system_b\" \"metadata\" \"rawdump\" \"cryptkey\" \"userdata\" \"PrimaryGPT\" \"BackupGPT\"
set part_lun1=\"xbl_a\" \"xbl_config_a\" \"last_parti\" \"PrimaryGPT\" \"BackupGPT\"
set part_lun2=\"xbl_b\" \"xbl_config_b\" \"last_parti\" \"PrimaryGPT\" \"BackupGPT\"
set part_lun3=\"ALIGN_TO_128K_1\" \"cdt\" \"ddr\" \"last_parti\" \"PrimaryGPT\" \"BackupGPT\"
set part_lun4=\"aop_a\" \"tz_a\" \"hyp_a\" \"modem_a\" \"bluetooth_a\" \"mdtpsecapp_a\" \"mdtp_a\" \"abl_a\" \"dsp_a\" \"keymaster_a\" \"boot_a\" \"cmnlib_a\" \"cmnlib64_a\" \"devcfg_a\" \"qupfw_a\" \"vendor_a\" \"system_a\" \"vbmeta_a\" \"dtbo_a\" \"uefisecapp_a\" \"imagefv_a\" \"fingerid_a\" \"vm-linux_a\" \"splash_a\" \"aop_b\" \"tz_b\" \"hyp_b\" \"modem_b\" \"bluetooth_b\" \"mdtpsecapp_b\" \"mdtp_b\" \"abl_b\" \"dsp_b\" \"keymaster_b\" \"boot_b\" \"cmnlib_b\" \"cmnlib64_b\" \"devcfg_b\" \"qupfw_b\" \"vendor_b\" \"system_b\" \"vbmeta_b\" \"dtbo_b\" \"uefisecapp_b\" \"imagefv_b\" \"fingerid_b\" \"vm-linux_b\" \"splash_b\" \"devinfo\" \"dip\" \"apdp\" \"msadp\"\"spunvm\" \"limits\" \"toolsfv\" \"logfs\" \"cateloader\" \"logdump\" \"storsec\" \"multiimgoem\" \"multiimgqti\" \"uefivarstore\" \"secdata\" \"catefv\" \"catecontentfv\" \"vm-keystore\" \"vm-data\" \"last_parti\" \"PrimaryGPT\" \"BackupGPT\"
set part_lun5=\"ALIGN_TO_128K_2\" \"modemst1\" \"modemst2\" \"fsg\" \"fsc\" \"ztecfg\" \"last_parti\" \"PrimaryGPT\" \"BackupGPT\"

reg add "HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" /v HideFileExt /t REG_DWORD /d 00000000 /f >NUL 2>NUL

taskkill /F /IM adb.exe >nul 2>NUL
taskkill /F /IM fastboot.exe >nul 2>NUL
start /B "" "%~dp0tools\adb.exe" start-server >NUL 2>NUL

call :Analis_Folders
call :Analis_Tools_Folder


rem **************************************************** MAIN ************************************************************
CLS
call :Warning
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0C -w 91 -e "!!! Whatever you do, you are at your own risk !!!"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "!!! If you are not sure, do not use this program !!!"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Information:"
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "Before you start using the program, make sure:"
ECHO.
"%~dp0tools\echox.exe" -c 08 " 1. The path to this program does not contain Russian letters and spaces," 
"%~dp0tools\echox.exe" -n -c 08 "    it is advisable to copy the program to the root of the drive " & "%~dp0tools\echox.exe" -n -c 0A "C:\" & "%~dp0tools\echox.exe" -n -c 08 " or " & "%~dp0tools\echox.exe" -c 0A "D:\"
ECHO.
"%~dp0tools\echox.exe" -c 08 " 2. You have drivers installed (install them from the Axon 10 Pro USB menu)"
ECHO.
"%~dp0tools\echox.exe" -c 08 " 3. You have rebooted the phone into EDL mode: 
ECHO.
"%~dp0tools\echox.exe" -c 0E " Automatically reboot into EDL mode (the program will reboot the phone into EDL mode):"
"%~dp0tools\echox.exe" -n -c 08 " - boot the phone into the system and allow " & "%~dp0tools\echox.exe" -n -c 0A "<USB Debugging>" & "%~dp0tools\echox.exe" -n -c 08 " in the menu " & "%~dp0tools\echox.exe" -c 0A "<Developer options>"
"%~dp0tools\echox.exe" -n -c 08 " - boot the phone into " & "%~dp0tools\echox.exe" -n -c 0A "FTM mode" & "%~dp0tools\echox.exe" -n -c 08 " using the key combination: " & "%~dp0tools\echox.exe" -c 0A "volume down + power"
ECHO.
"%~dp0tools\echox.exe" -c 0E " Manually reboot into EDL mode:"
"%~dp0tools\echox.exe" -n -c 08 " - use the command: " & "%~dp0tools\echox.exe" -c 0B "adb reboot edl" 
ECHO.
"%~dp0tools\echox.exe" -c 08 " 4. The phone is recognized in the Windows Device Manager as:"
"%~dp0tools\echox.exe" -n -c 08 " - " & "%~dp0tools\echox.exe" -c 0E "Qualcomm HS-USB QDLoader 9008"
"%~dp0tools\echox.exe" -n -c 08 " - " & "%~dp0tools\echox.exe" -c 0D "ZTE Handset Diagnostic Interface(DFU)"
ECHO.
"%~dp0tools\echox.exe" -c 0B -w 91 -e "(c) djkuz (4pda.ru) 2019"
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Do you want to continue using the program? Y - Yes, N - No"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
choice /C YN /N >nul
if /i %errorlevel% equ 2 Exit

:Main_Screen
CLS
call :Find_Phone >nul
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0B -w 91 -e "ZTE Axon 10 Pro - Flash / Backup / Restore / Bootloader Unlock"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
if not defined comport (goto :Main_Menu_Hide)
if "%phone_mode%" equ "DFU" (goto :Main_Munu_DFU)
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Phone is connected !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
call :Show_Main_Menu
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "1. Flash"
"%~dp0tools\echox.exe" -c 02 -w 91 -e "(FULL EDL, Boot+Recovery, Modem)"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "2. Backup"
"%~dp0tools\echox.exe" -c 06 -w 91 -e "(All partitions, FULL EDL, Boot+Recovery, Modem)"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "3. Restore"
"%~dp0tools\echox.exe" -c 05 -w 91 -e "(All partitions, FULL EDL, Boot+Recovery, Modem)"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "4. Unlock"
"%~dp0tools\echox.exe" -c 04 -w 91 -e "(Bootloader and Google FRP Unlock)"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -n -c 0E " H - Help" & "%~dp0tools\echox.exe" -n -c 0A -w 71 -e " Choose an option" & "%~dp0tools\echox.exe" -c 0D -w 11 -r "Q - Quit"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="

choice /C 1234HQ /N >nul
if /i %errorlevel% equ 1 goto :Menu_Flash
if /i %errorlevel% equ 2 goto :Menu_Backup
if /i %errorlevel% equ 3 goto :Menu_Restore
if /i %errorlevel% equ 4 goto :Menu_Unlock
if /i %errorlevel% equ 5 goto :Main_HELP
if /i %errorlevel% equ 6 Exit
goto :Main_Screen

:Main_Menu_Hide
"%~dp0tools\echox.exe" -c 0C -w 91 -e "??? Phone not found ???"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
ECHO.
call :Phone_Search
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Automatically reboot into EDL mode !!!"
ECHO.
ECHO.
call :Reboot_EDL
goto :Main_Screen

:Main_Munu_DFU
"%~dp0tools\echox.exe" -c 0C -w 91 -e "!!! Phone is in DFU mode !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
ECHO.
ECHO.
ECHO.
call :Phone_DFU
ECHO.
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Trying to automatically reboot in EDL mode !!!"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Rebooting the phone into EDL mode:"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Command execution " & "%~dp0tools\echox.exe" -n -c 0A "reboot edl" & "%~dp0tools\echox.exe" -n -c 0F " >>> "
"%~dp0tools\emmcdl.exe" -p COM%comport% -raw 0xFE >nul 2>&1
"%~dp0tools\echox.exe" -n -c 0D "the command is executed" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0B "reboot"
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Wait !!!"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
timeout /t 5 /NOBREAK >nul 2>nul
goto :Main_Screen

:Menu_Flash
CLS
call :Find_Phone >nul
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0B -w 91 -e "ZTE Axon 10 Pro - Flash / Backup / Restore / Bootloader Unlock"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
if not defined comport (goto :Main_Menu_Hide)
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Phone is connected !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
call :Show_Flash_Menu
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "1. Flash Full EDL"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "2. Flash Boot"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "3. Flash Modem"
ECHO.
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -n -c 0E " H - Help" & "%~dp0tools\echox.exe" -n -c 0A -w 71 -e " Choose what you need to flash" & "%~dp0tools\echox.exe" -c 0D -w 11 -r "Q - Back"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="

choice /C 123HQ /N >nul
if /i %errorlevel% equ 1 call :Flash "Full EDL" "full"
if /i %errorlevel% equ 2 call :Flash "Boot" "boot"
if /i %errorlevel% equ 3 call :Flash "Modem" "modem"
if /i %errorlevel% equ 4 goto :Flash_HELP
if /i %errorlevel% equ 5 goto :Main_Screen
goto :Menu_Flash

:Menu_Backup
CLS
call :Find_Phone >nul
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0B -w 91 -e "ZTE Axon 10 Pro - Flash / Backup / Restore / Bootloader Unlock"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
if not defined comport (goto :Main_Menu_Hide)
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Phone is connected !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
call :Show_Backup_Menu
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "1. Backup all partitions"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "2. Backup Full EDL"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "3. Backup Boot"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "4. Backup Modem"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -n -c 0E " H - Help" & "%~dp0tools\echox.exe" -n -c 0A -w 71 -e " Choose a backup option" & "%~dp0tools\echox.exe" -c 0D -w 11 -r "Q - Back"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="

choice /C 1234HQ /N >nul
if /i %errorlevel% equ 1 call :Backup "all partitions" "all"
if /i %errorlevel% equ 2 call :Backup "Full EDL" "full"
if /i %errorlevel% equ 3 call :Backup "Boot" "boot"
if /i %errorlevel% equ 4 call :Backup "Modem" "modem"
if /i %errorlevel% equ 5 goto :Backup_HELP
if /i %errorlevel% equ 6 goto :Main_Screen
goto :Menu_Backup

:Menu_Restore
CLS
call :Find_Phone >nul
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0B -w 91 -e "ZTE Axon 10 Pro - Flash / Backup / Restore / Bootloader Unlock"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
if not defined comport (goto :Main_Menu_Hide)
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Phone is connected !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
call :Show_Restore_Menu
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "1. Restore all partitions from backup"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "2. Restore Full EDL from backup"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "3. Restore Boot from backup"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "4. Restore Modem from backup"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -n -c 0E " H - Help" & "%~dp0tools\echox.exe" -n -c 0A -w 71 -e " Choose a restore option" & "%~dp0tools\echox.exe" -c 0D -w 11 -r "Q - Back"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="

choice /C 1234HQ /N >nul
if /i %errorlevel% equ 1 call :Restore "all partitions" "all"
if /i %errorlevel% equ 2 call :Restore "Full EDL" "full"
if /i %errorlevel% equ 3 call :Restore "Boot" "boot"
if /i %errorlevel% equ 4 call :Restore "Modem" "modem"
if /i %errorlevel% equ 5 goto :Restore_HELP
if /i %errorlevel% equ 6 goto :Main_Screen
goto :Menu_Restore

:Menu_Unlock
CLS
call :Find_Phone >nul
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0B -w 91 -e "ZTE Axon 10 Pro - Flash / Backup / Restore / Bootloader Unlock"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
if not defined comport (goto :Main_Menu_Hide)
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Phone is connected !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
call :Show_Unlock_Menu
ECHO.
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "1. Bootloader Unlock"
ECHO.
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "2. Google FRP Unlock"
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -n -c 0E " H - Help" & "%~dp0tools\echox.exe" -n -c 0A -w 71 -e " Choose an unlock option" & "%~dp0tools\echox.exe" -c 0D -w 11 -r "Q - Back"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="

choice /C 12HQ /N >nul
if /i %errorlevel% equ 1 call :Bootloader_Unlock_Warning
if /i %errorlevel% equ 2 call :Unlock "Google FRP Unlock" "frp_unlock"
if /i %errorlevel% equ 3 goto :Unlock_HELP
if /i %errorlevel% equ 4 goto :Main_Screen
goto :Menu_Unlock

rem *************************************************** END MAIN *********************************************************

rem ***************************************************** Flash **********************************************************
:Flash
CLS
call :Find_Phone >nul
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "Flash %~1"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
if not defined comport (goto :Main_Screen)
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Phone is connected !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -n -c 0D "			       File analysis: "
if %~2 equ full (call :Analis_Files_FULL_EDL) else (call :Analis_Files "%~2" "flash\%~2" "Flash")
"%~dp0tools\echox.exe" -c 0A "Success"
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Flash partitions:"
ECHO.
if %~2 equ full (call :Show_Flash_Part "flash\%~2\rawprogram" "5") else (call :Show_Flash_Part "tools\%~2" "1")
call :Info_Show
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Do you want to begin flash? Y - Yes, N - No"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
choice /C YN /N >nul
if /i %errorlevel% neq 1 goto :Menu_Flash
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
call :Show_Flash_Menu
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "Flash %~1"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -n -c 0E " Loading the programmer: "
"%~dp0tools\echox.exe" -n -c 0D "prog_ufs_firehose_sdm855.elf"
"%~dp0tools\echox.exe" -n -c 0F " >>> "
if exist %~dp0logs\Flash.log (del /F %~dp0logs\Flash.log >nul 2>nul)
call :Load_Programmer "%~dp0logs\Flash.log"
ECHO.
if %~2 equ full (call :Show_Flash_Part "flash\%~2\rawprogram" "5") else (call :Show_Flash_Part "tools\%~2" "1")
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
start %~dp0tools\ConsoleNoClose.exe /1 >nul 2>nul
if %~2 equ full (start /wait "Flash partitions! ...Wait..." cmd /c " color 02 & mode con cols=92 lines=80 & "%~dp0tools\fh_loader.exe" --port=\\.\COM%comport% --sendxml=rawprogram0.xml,patch0.xml,rawprogram1.xml,patch1.xml,rawprogram2.xml,patch2.xml,rawprogram3.xml,patch3.xml,rawprogram4.xml,patch4.xml,rawprogram5.xml,patch5.xml --search_path="%~dp0flash\%~2,%~dp0tools" --mainoutputdir="%~dp0logs" --noprompt --showpercentagecomplete --zlpawarehost=1 --memoryname=ufs & timeout /t 5"
) else (start /wait "Flash partitions! ...Wait..." cmd /c " color 02 & mode con cols=92 lines=80 & "%~dp0tools\fh_loader.exe" --port=\\.\COM%comport% --sendxml=%~2.xml --search_path="%~dp0flash\%~2,%~dp0tools" --mainoutputdir="%~dp0logs" --noprompt --showpercentagecomplete --zlpawarehost=1 --memoryname=ufs & timeout /t 5")
Taskkill /F /IM ConsoleNoClose.exe >nul 2>nul
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
for /f "tokens=4 delims=: " %%a in ('find /c "ERROR" %~dp0logs\port_trace.txt') do set /a status=%%a
ECHO.
if %status% equ 0 (call :Success) else (call :Failure)
type %~dp0logs\port_trace.txt>>%~dp0logs\Flash.log
del /F %~dp0logs\port_trace.txt >nul 2>nul
call :Date_Time
ren %~dp0logs\Flash.log Flash_%DTTM%.log
ECHO.
"%~dp0tools\echox.exe" -n -c 08 " LOG-file: " & "%~dp0tools\echox.exe" -c 06 "Flash_%DTTM%.log"
ECHO.
if %status% equ 0 (set programmer=1 & call :Ask_Reboot) else (call :Ask_Any_Key_Next)
goto :Main_Screen
rem ****************************************************** END Flash *****************************************************

rem ******************************************************** Backup ******************************************************
:Backup
CLS
call :Find_Phone >nul
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Backup %~1"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
if not defined comport (goto :Main_Screen)
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Phone is connected !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -n -c 0D "			       Folder analysis: "
call :Analis_Files_Backup "%~2" "backup\%~2"
if defined backup_yes goto :Backup_GO
"%~dp0tools\echox.exe" -c 0A "Success"
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Backup partitions:"
ECHO.
call :Show_Flash_Part "tools\%~2" "1"
call :Info_Show
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Do you want to begin backup? Y - Yes, N - No"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
choice /C YN /N >nul
if /i %errorlevel% neq 1 goto :Menu_Backup
:Backup_GO
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
call :Show_Backup_Menu
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Backup %~1"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -n -c 0E " Loading the programmer: "
"%~dp0tools\echox.exe" -n -c 0D "prog_ufs_firehose_sdm855.elf"
"%~dp0tools\echox.exe" -n -c 0F " >>> "
if exist %~dp0backup\%~2\Backup.log (del /F %~dp0backup\%~2\Backup.log >nul 2>nul)
call :Load_Programmer "%~dp0backup\%~2\Backup.log"
ECHO.
call :Show_Flash_Part "tools\%~2" "1"
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
start %~dp0tools\ConsoleNoClose.exe /1 >nul 2>nul
start /wait "Backup partitions! ...Wait..." cmd /c " color 02 & mode con cols=92 lines=80 & "%~dp0tools\fh_loader.exe" --port=\\.\COM%comport% --sendxml=%~2.xml --search_path="%~dp0tools" --mainoutputdir="%~dp0backup\%~2" --showpercentagecomplete --memoryname=ufs --convertprogram2read --showdigestperfile --loglevel=0 & timeout /t 5"
Taskkill /F /IM ConsoleNoClose.exe >nul 2>nul
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
for %%i in (%~dp0backup\%~2\DigestsPerFile.txt) do (set /a size=%%~Zi)
if %size% neq 0 (call :Success & ECHO.Backup_%~2_%DTTM%>%~dp0backup\%~2\Backup_Info.txt) else (call :Failure & type %~dp0backup\%~2\port_trace.txt>>%~dp0backup\%~2\Backup.log)
ECHO.
call :LOG_Backup_Part_Files "%~2"
del /F %~dp0backup\%~2\port_trace.txt >nul 2>nul
del /F %~dp0backup\%~2\Backup_Files.log >nul 2>nul
del /F %~dp0backup\%~2\DigestsPerFile.txt >nul 2>nul
call :Date_Time
move %~dp0backup\%~2\Backup.log %~dp0logs\Backup_%DTTM%.log >nul 2>nul
ECHO.
"%~dp0tools\echox.exe" -n -c 08 " LOG-file: " & "%~dp0tools\echox.exe" -c 06 "Backup_%DTTM%.log"
if %size% neq 0 (set programmer=1 & call :Ask_Reboot) else (call :Ask_Any_Key_Next)
goto :Main_Screen
rem **************************************************** END Backup ******************************************************

rem ***************************************************** Restore ********************************************************
:Restore
CLS
call :Find_Phone >nul
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0D -w 91 -e "Restore %~1 from backup"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
if not defined comport (goto :Main_Screen)
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Phone is connected !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -n -c 0D "			       File analysis: "
call :Analis_Files "%~2" "backup\%~2" "Restore"
"%~dp0tools\echox.exe" -c 0A "Success"
ECHO.
set backup=
for /f "delims=" %%a in (%~dp0backup\%~2\Backup_Info.txt) do (set backup=%%a)
"%~dp0tools\echox.exe" -n -c 0F "                      Restore from backup: "
if defined backup ("%~dp0tools\echox.exe" -c 0C  "%backup%") else ("%~dp0tools\echox.exe" -c 0C  "!!! no data !!!")
ECHO.
call :Show_Flash_Part "tools\%~2" "1"
call :Info_Show
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Do you want to begin restore? Y - Yes, N - No"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
choice /C YN /N >nul
if /i %errorlevel% neq 1 goto :Menu_Restore
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
call :Show_Restore_Menu
ECHO.
"%~dp0tools\echox.exe" -c 0D -w 91 -e "Restore %~1 from backup"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "%backup%"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -n -c 0E " Loading the programmer: "
"%~dp0tools\echox.exe" -n -c 0D "prog_ufs_firehose_sdm855.elf"
"%~dp0tools\echox.exe" -n -c 0F " >>> "
if exist %~dp0logs\Restore.log (del /F %~dp0logs\Restore.log >nul 2>nul)
call :Load_Programmer "%~dp0logs\Restore.log"
ECHO.
call :Show_Flash_Part "tools\%~2" "1"
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
start %~dp0tools\ConsoleNoClose.exe /1 >nul 2>nul
start /wait "Restore from backup! ...Wait..." cmd /c " color 02 & mode con cols=92 lines=80 & "%~dp0tools\fh_loader.exe" --port=\\.\COM%comport% --sendxml=%~2.xml --search_path="%~dp0backup\%~2,%~dp0tools" --mainoutputdir="%~dp0logs" --noprompt --showpercentagecomplete --zlpawarehost=1 --memoryname=ufs & timeout /t 5"
Taskkill /F /IM ConsoleNoClose.exe >nul 2>nul
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
for /f "tokens=4 delims=: " %%a in ('find /c "ERROR" %~dp0logs\port_trace.txt') do set /a status=%%a
ECHO.
if %status% equ 0 (call :Success) else (call :Failure)
type %~dp0logs\port_trace.txt>>%~dp0logs\Restore.log
del /F %~dp0logs\port_trace.txt >nul 2>nul
call :Date_Time
ren %~dp0logs\Restore.log Restore_%DTTM%.log
ECHO.
"%~dp0tools\echox.exe" -n -c 08 " LOG-file: " & "%~dp0tools\echox.exe" -c 06 "Restore_%DTTM%.log"
rem ECHO.
if %status% equ 0 (set programmer=1 & call :Ask_Reboot) else (call :Ask_Any_Key_Next)
goto :Main_Screen
rem **************************************************** END Restore *****************************************************

rem ****************************************************** Unlock ********************************************************
:Unlock
CLS
call :Find_Phone >nul
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0C -w 91 -e "%~1"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
if not defined comport (goto :Main_Screen)
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Phone is connected !!!"
call :Port_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -n -c 0D "			       File analysis: "
call :Analis_Files "%~2" "unlock" "Unlock"
"%~dp0tools\echox.exe" -c 0A "Success"
ECHO.
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Flash partitions:"
ECHO.
call :Show_Flash_Part "tools\%~2" "1"
call :Info_Show
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Do you want to begin flash? Y - Yes, N - No"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
choice /C YN /N >nul
if /i %errorlevel% neq 1 goto :Menu_Unlock
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
call :Show_Unlock_Menu
ECHO.
"%~dp0tools\echox.exe" -c 0C -w 91 -e "%~1"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -n -c 0E " Loading the programmer: "
"%~dp0tools\echox.exe" -n -c 0D "prog_ufs_firehose_sdm855.elf"
"%~dp0tools\echox.exe" -n -c 0F " >>> "
if exist %~dp0logs\Unlock.log (del /F %~dp0logs\Unlock.log >nul 2>nul)
call :Load_Programmer "%~dp0logs\Unlock.log"
ECHO.
call :Show_Flash_Part "tools\%~2" "1"
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
start %~dp0tools\ConsoleNoClose.exe /1 >nul 2>nul
start /wait "Flash partitions! ...Wait..." cmd /c " color 02 & mode con cols=92 lines=80 & "%~dp0tools\fh_loader.exe" --port=\\.\COM%comport% --sendxml=%~2.xml --search_path="%~dp0unlock,%~dp0tools" --mainoutputdir="%~dp0logs" --noprompt --showpercentagecomplete --zlpawarehost=1 --memoryname=ufs & timeout /t 5"
Taskkill /F /IM ConsoleNoClose.exe >nul 2>nul
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
for /f "tokens=4 delims=: " %%a in ('find /c "ERROR" %~dp0logs\port_trace.txt') do set /a status=%%a
ECHO.
if %status% equ 0 (call :Success) else (call :Failure)
type %~dp0logs\port_trace.txt>>%~dp0logs\Unlock.log
del /F %~dp0logs\port_trace.txt >nul 2>nul
call :Date_Time
ren %~dp0logs\Unlock.log Unlock_%DTTM%.log
ECHO.
"%~dp0tools\echox.exe" -n -c 08 " LOG-file: " & "%~dp0tools\echox.exe" -c 06 "Unlock_%DTTM%.log"
ECHO.
if %status% equ 0 (if %~2 equ unlock (set programmer=1 & call :Ask_Any_Key_Next & goto Automatic_Flashing_Unlock) else (set programmer=1 & call :Ask_Reboot)) else (call :Ask_Any_Key_Next)
goto :Main_Screen
rem ***************************************************** END Unlock *****************************************************

rem ************************************************* Automatic_Flashing_Unlock ************************************************
:Automatic_Flashing_Unlock
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
call :Show_Automatic
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
"%~dp0tools\fh_loader.exe" --port=\\.\COM%comport% --sendxml=reset.xml --search_path="%~dp0tools" --mainoutputdir="%~dp0logs" --noprompt --showpercentagecomplete --zlpawarehost=1 --memoryname=ufs >nul 2>nul
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
if exist %~dp0logs\port_trace.txt (del /F %~dp0logs\port_trace.txt >nul 2>nul)
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Try to automatically unlock bootloader !!!"
ECHO.
"%~dp0tools\echox.exe" -c 0B -w 91 -e "... Waiting for the phone to boot into the System or into the Fastboot (Bootloader) ..."
ECHO.
"%~dp0tools\echox.exe" -n -c 08 "                    Check again that you are allowed to " & "%~dp0tools\echox.exe" -c 0A "<Unlock OEM>" 
"%~dp0tools\echox.exe" -n -c 08 "                   and " & "%~dp0tools\echox.exe" -n -c 0A "<USB Debugging>" & "%~dp0tools\echox.exe" -n -c 08 " in the menu " & "%~dp0tools\echox.exe" -c 0A "<Developer Options>"
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0D -w 91 -e "!!! Wait for the phone to boot into the system or boot into the Fastboot (Bootloader)"
"%~dp0tools\echox.exe" -c 0D -w 91 -e "and press any key !!!"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
pause >nul
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Search ADB Interface:" & "%~dp0tools\echox.exe" -n -c 0F " >>> "
"%~dp0tools\devcon.exe" find * | findstr "ADB" >nul 2>&1
IF "%ERRORLEVEL%" equ "0" (for /f  "tokens=2 delims=:" %%i in ('"%~dp0tools\devcon.exe" find ^* ^| findstr ADB') do ("%~dp0tools\echox.exe" -n -c 0D "interface found" & "%~dp0tools\echox.exe" -n -c 0F " >>>" & "%~dp0tools\echox.exe" -c 0B "%%i")) else  ("%~dp0tools\echox.exe" -c 0C "!!! Error !!! ADB Interface not found" & call :No_ADB_Inteface_Unlock)
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Command execution " & "%~dp0tools\echox.exe" -n -c 0E "adb/fastboot devices" & "%~dp0tools\echox.exe" -n -c 0F " >>> "
"%~dp0tools\fastboot.exe" devices | findstr "fastboot" >nul 2>&1
IF "%ERRORLEVEL%" equ "0" (for /f %%z in ('"%~dp0tools\fastboot.exe" devices') do ("%~dp0tools\echox.exe" -n -c 0D "answer received" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0A "Fastboot mode: %%z" & goto :Find_Fastboot_Unlock))
"%~dp0tools\adb.exe" devices | findstr "\<device\>" >nul 2>&1
IF "%ERRORLEVEL%" equ "0" (for /f "skip=1" %%z in ('"%~dp0tools\adb.exe" devices') do ("%~dp0tools\echox.exe" -n -c 0D "answer received" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0F "System mode: %%z")) else  ("%~dp0tools\echox.exe" -c 0C "!!! Error !!! no answer from phone" & call :No_ADB_devices_Unlock)
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Command execution " & "%~dp0tools\echox.exe" -n -c 0A "adb reboot bootloader" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -n -c 0D "the command is executed" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0B "boot into Fastboot"
"%~dp0tools\adb.exe" reboot bootloader >nul 2>&1
timeout /t 5 /NOBREAK >nul 2>nul
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Command execution " & "%~dp0tools\echox.exe" -n -c 0E "fastboot devices" & "%~dp0tools\echox.exe" -n -c 0F " >>> "
"%~dp0tools\fastboot.exe" devices | findstr "fastboot" >nul 2>&1
IF "%ERRORLEVEL%" equ "0" (for /f %%z in ('"%~dp0tools\fastboot.exe" devices') do ("%~dp0tools\echox.exe" -n -c 0D "answer received" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0A "Fastboot mode: %%z")) else  ("%~dp0tools\echox.exe" -c 0C "!!! Error !!! no answer from phone" & goto :No_Fastboot_Unlock)
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Command execution " & "%~dp0tools\echox.exe" -n -c 0A "fastboot flashing unlock" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -n -c 0D "the command is executed" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0E "!!! unlocking !!!"
ECHO.
"%~dp0tools\fastboot.exe" flashing unlock >nul 2>&1
IF "%ERRORLEVEL%" equ "0" (call :Show_Unlocked) else (call :Failure)
ECHO.
call :Ask_Any_Key_Exit
goto :Automatic_Flashing_Unlock

:Find_Fastboot_Unlock
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Command execution " & "%~dp0tools\echox.exe" -n -c 0A "fastboot flashing unlock" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -n -c 0D "the command is executed" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0E "!!! unlocking !!!"
ECHO.
ECHO.
ECHO.
"%~dp0tools\fastboot.exe" flashing unlock >nul 2>&1
IF "%ERRORLEVEL%" equ "0" (call :Show_Unlocked) else (call :Failure)
ECHO.
ECHO.
call :Ask_Any_Key_Exit
goto :Automatic_Flashing_Unlock

:No_ADB_Inteface_Unlock
ECHO.
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0D -w 91 -e "Possible solutions to the problem:"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 1. Boot the phone to the system and allow " & "%~dp0tools\echox.exe" -n -c 0A "<USB Debugging>" & "%~dp0tools\echox.exe" -n -c 07 " in the menu " & "%~dp0tools\echox.exe" -c 0A "<Developer Options>"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 2. Boot the phone into the " & "%~dp0tools\echox.exe" -n -c 0A "FTM mode" & "%~dp0tools\echox.exe" -n -c 07 " through the key combination: " & "%~dp0tools\echox.exe" -c 0A "volume down + power"
ECHO.
ECHO.
ECHO.
ECHO.
call :Ask_Any_Key_Repeat
goto :Automatic_Flashing_Unlock
Exit /B

:No_ADB_devices_Unlock
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0D -w 91 -e "Possible solutions to the problem:"
ECHO.
"%~dp0tools\echox.exe" -c 07 -w 91 -e "On the screen of your phone there is a request for the system to allow debugging via USB,"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 "                                confirm it - press " & "%~dp0tools\echox.exe" -c 0A "<Yes>"
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
call :Ask_Any_Key_Repeat
goto :Automatic_Flashing_Unlock
Exit /B

:No_Fastboot_Unlock
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0C -w 91 -e "!!! Error! !! Fastboot mode (Bootloader) not detected"
ECHO.
"%~dp0tools\echox.exe" -c 07 -w 91 -e "!!! Repeat the unlock procedure !!!"
ECHO.
ECHO.
ECHO.
call :Ask_Any_Key_Exit
goto :Automatic_Flashing_Unlock
Exit /B

rem ********************************************** END Automatic_Flashing_Unlock ***********************************************

rem ************************************************* Load_Programmer ****************************************************
:Load_Programmer
if defined programmer ("%~dp0tools\echox.exe" -c 0A "!!! Already loaded !!!" & Exit /B)
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
"%~dp0tools\emmcdl.exe" -p COM%comport% -f "%~dp0tools\prog_ufs_firehose_sdm855.elf" >%~1
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
for /f "tokens=4 delims=: " %%a in ('find /c "Status: 0" %~1') do set /a status=%%a
if %status% equ 0 ("%~dp0tools\echox.exe" -c 0E "Error, trying to continue...") else ("%~dp0tools\echox.exe" -c 0A "Success" & set programmer=1)
Exit /B
rem *********************************************** END Load_Programmer **************************************************

rem ******************************************************* Reboot *******************************************************
:Reboot
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
"%~dp0tools\fh_loader.exe" --port=\\.\COM%comport% --sendxml=reset.xml --search_path="%~dp0tools" --mainoutputdir="%~dp0logs" --noprompt --showpercentagecomplete --zlpawarehost=1 --memoryname=ufs >nul 2>nul
rem >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
if exist %~dp0logs\port_trace.txt (del /F %~dp0logs\port_trace.txt >nul 2>nul)
Exit
rem ***************************************************** END Reboot *****************************************************

rem ***************************************************** Main Help ******************************************************
:Main_HELP
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Help"
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "Before you start using the program, make sure:"
ECHO.
"%~dp0tools\echox.exe" -c 08 " 1. The path to this program does not contain Russian letters and spaces," 
"%~dp0tools\echox.exe" -n -c 08 "    it is advisable to copy the program to the root of the drive " & "%~dp0tools\echox.exe" -n -c 0A "C:\" & "%~dp0tools\echox.exe" -n -c 08 " or " & "%~dp0tools\echox.exe" -c 0A "D:\"
ECHO.
"%~dp0tools\echox.exe" -c 08 " 2. You have drivers installed (install them from the Axon 10 Pro USB menu)"
ECHO.
"%~dp0tools\echox.exe" -c 08 " 3. You have rebooted the phone into EDL mode: 
ECHO.
"%~dp0tools\echox.exe" -c 0E " Automatically reboot into EDL mode (the program will reboot the phone into EDL mode):"
"%~dp0tools\echox.exe" -n -c 08 " - boot the phone into the system and allow " & "%~dp0tools\echox.exe" -n -c 0A "<USB Debugging>" & "%~dp0tools\echox.exe" -n -c 08 " in the menu " & "%~dp0tools\echox.exe" -c 0A "<Developer options>"
"%~dp0tools\echox.exe" -n -c 08 " - boot the phone into " & "%~dp0tools\echox.exe" -n -c 0A "FTM mode" & "%~dp0tools\echox.exe" -n -c 08 " using the key combination: " & "%~dp0tools\echox.exe" -c 0A "volume down + power"
ECHO.
"%~dp0tools\echox.exe" -c 0E " Manually reboot into EDL mode:"
"%~dp0tools\echox.exe" -n -c 08 " - use the command: " & "%~dp0tools\echox.exe" -c 0B "adb reboot edl" 
ECHO.
"%~dp0tools\echox.exe" -c 08 " 4. The phone is recognized in the Windows Device Manager as:"
"%~dp0tools\echox.exe" -n -c 08 " - " & "%~dp0tools\echox.exe" -c 0E "Qualcomm HS-USB QDLoader 9008"
"%~dp0tools\echox.exe" -n -c 08 " - " & "%~dp0tools\echox.exe" -c 0D "ZTE Handset Diagnostic Interface(DFU)"
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Note:"
ECHO.
"%~dp0tools\echox.exe" -c 08 -w 91 -e "Reboot into EDL mode if any error occurs!!!"
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "The folder structure of the program:"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 1. folder " & "%~dp0tools\echox.exe" -n -c 0A "flash" & "%~dp0tools\echox.exe" -c 07 " - Copy the files you want to flash into this folder" 
"%~dp0tools\echox.exe" -n -c 07 " 2. folder " & "%~dp0tools\echox.exe" -n -c 0A "backup" & "%~dp0tools\echox.exe" -c 07 " - contains the backup of the phone's partitions created by the program"
"%~dp0tools\echox.exe" -n -c 07 " 3. folder " & "%~dp0tools\echox.exe" -n -c 0A "logs" & "%~dp0tools\echox.exe" -c 07 " - contains all logs of the program"
"%~dp0tools\echox.exe" -n -c 07 " 4. folder " & "%~dp0tools\echox.exe" -n -c 0A "unlock" & "%~dp0tools\echox.exe" -n -c 07 " - contains all the necessary files for unlock" & "%~dp0tools\echox.exe" -c 0C " (do not touch it!)"
"%~dp0tools\echox.exe" -n -c 07 " 5. folder " & "%~dp0tools\echox.exe" -n -c 0A "tools" & "%~dp0tools\echox.exe" -n -c 07 " - contains all the necessary files for the program" & "%~dp0tools\echox.exe" -c 0C " (do not touch it!)"
ECHO.
call :Ask_Any_Key_Next
goto :Main_Screen
rem ***************************************************** END Main Help ***************************************************

rem ****************************************************** Flash Help *****************************************************
:Flash_HELP
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Help on <Flashing>"
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
call :Show_Flash_Menu
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "Folder structure: Axon10_EDL_Tool\flash"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 1. Folder " & "%~dp0tools\echox.exe" -n -c 0A "full" & "%~dp0tools\echox.exe" -c 07 " - if you want to flash the full firmware (official, adapted for EDL mode)"
"%~dp0tools\echox.exe" -c 07 "    then in this folder you need to put all the files from the firmware for EDL mode:"
"%~dp0tools\echox.exe" -n -c 07 "    usually it's named like this: " & "%~dp0tools\echox.exe" -c 0D "A2020_......._FULL_EDL" 
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 2. Folder " & "%~dp0tools\echox.exe" -n -c 0A "boot" & "%~dp0tools\echox.exe" -c 07 " - if you want to flash your Boot Image, you need to put it in this folder"
"%~dp0tools\echox.exe" -n -c 07 "    filename: " & "%~dp0tools\echox.exe" -n -c 0D "boot.img" & "%~dp0tools\echox.exe" -c 0C " (the filename must be exact!)"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 3. Folder " & "%~dp0tools\echox.exe" -n -c 0A "modem" & "%~dp0tools\echox.exe" -c 07 " - if you want to flash your modem file, you need to put it in this folder"
"%~dp0tools\echox.exe" -n -c 07 "    filename: " & "%~dp0tools\echox.exe" -n -c 0D "NON-HLOS.bin" & "%~dp0tools\echox.exe" -c 0C " (the filename must be exact!)"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Note:"
ECHO.
"%~dp0tools\echox.exe" -c 08 -w 91 -e "Reboot into EDL mode if any error occurs!!!"
ECHO.
ECHO.
call :Ask_Any_Key_Next
goto :Menu_Flash
rem **************************************************** END Flash Help ***************************************************

rem ***************************************************** Backup Help *****************************************************
:Backup_HELP
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Help on <Backing Up>"
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
call :Show_Backup_Menu
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "Folder structure: Axon10_EDL_Tool\backup"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 1. Folder " & "%~dp0tools\echox.exe" -n -c 0A "all" & "%~dp0tools\echox.exe" -n -c 07 " - this folder contains a backup of all partitions, except for " & "%~dp0tools\echox.exe" -c 0C "userdata"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 2. Folder " & "%~dp0tools\echox.exe" -n -c 0A "full" & "%~dp0tools\echox.exe" -c 07 " - this folder contains a backup of all partitions"
"%~dp0tools\echox.exe" -n -c 07 "    in the firmware " & "%~dp0tools\echox.exe" -c 0D "FULL EDL"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 3. Folder " & "%~dp0tools\echox.exe" -n -c 0A "boot" & "%~dp0tools\echox.exe" -n -c 07 " - this folder contains a backup of partition " & "%~dp0tools\echox.exe" -c 0D "boot"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 4. Folder " & "%~dp0tools\echox.exe" -n -c 0A "modem" & "%~dp0tools\echox.exe" -n -c 07 " - this folder contains a backup of partition " & "%~dp0tools\echox.exe" -c 0D "modem"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Note:"
ECHO.
"%~dp0tools\echox.exe" -c 08 -w 91 -e "Reboot into EDL mode if any error occurs!!!"
ECHO.
call :Ask_Any_Key_Next
goto :Menu_Backup
rem *************************************************** END Backup Help ***************************************************

rem **************************************************** Restore Help *****************************************************
:Restore_HELP
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Help on <Restoring from backup>"
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
call :Show_Restore_Menu
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "Folder structure: Axon10_EDL_Tool\backup"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 1. Folder " & "%~dp0tools\echox.exe" -n -c 0A "all" & "%~dp0tools\echox.exe" -c 07 " - Restores all the backed up partitions"
"%~dp0tools\echox.exe" -n -c 07 "    except for " & "%~dp0tools\echox.exe" -c 0C "userdata"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 2. Folder " & "%~dp0tools\echox.exe" -n -c 0A "full" & "%~dp0tools\echox.exe" -c 07 " - Restores all backed up partitions"
"%~dp0tools\echox.exe" -n -c 07 "    in the firmware " & "%~dp0tools\echox.exe" -c 0D "FULL EDL"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 3. Folder " & "%~dp0tools\echox.exe" -n -c 0A "boot" & "%~dp0tools\echox.exe" -n -c 07 " - Restores backed up partition of the " & "%~dp0tools\echox.exe" -c 0D "boot"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 4. Folder " & "%~dp0tools\echox.exe" -n -c 0A "modem" & "%~dp0tools\echox.exe" -n -c 07 " - Restores backed up partition of the " & "%~dp0tools\echox.exe" -c 0D "modem"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Note:"
ECHO.
"%~dp0tools\echox.exe" -c 08 -w 91 -e "Reboot into EDL mode if any error occurs!!!"
ECHO.
call :Ask_Any_Key_Next
goto :Menu_Restore
rem *************************************************** END Restore Help **************************************************

rem ***************************************************** Unlock Help *****************************************************
:Unlock_HELP
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Help on <Unlocking>"
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
call :Show_Unlock_Menu
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "Folder structure: Axon10_EDL_Tool\unlock"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 "      Folder " & "%~dp0tools\echox.exe" -n -c 0A "unlock" & "%~dp0tools\echox.exe" -n -c 07 " - contains all the necessary files for unlock" & "%~dp0tools\echox.exe" -c 0C " (do not touch it!)"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 1. Menu item " & "%~dp0tools\echox.exe" -n -c 0D "Bootloader Unlock" & "%~dp0tools\echox.exe" -c 07 ":"
"%~dp0tools\echox.exe" -n -c 08 "    flashes " & "%~dp0tools\echox.exe" -n -c 0A "aboot_a" & "%~dp0tools\echox.exe" -n -c 08 " and " & "%~dp0tools\echox.exe" -n -c 0A "aboot_b" & "%~dp0tools\echox.exe" -c 08 " - to enable fastboot on both slots."
ECHO.
"%~dp0tools\echox.exe" -c 0C -w 91 -e "!!! WARNING !!!"
"%~dp0tools\echox.exe" -c 0E -w 91 -e "After flashing the files, the program will start the process" 
"%~dp0tools\echox.exe" -c 0E -w 91 -e "of automatically unlocking the bootloader"
"%~dp0tools\echox.exe" -n -c 08 "                    Check again that you are allowed to " & "%~dp0tools\echox.exe" -c 0A "<OEM Unlock>" 
"%~dp0tools\echox.exe" -n -c 08 "                   and " & "%~dp0tools\echox.exe" -n -c 0A "<USB Debugging>" & "%~dp0tools\echox.exe" -n -c 08 " in the menu " & "%~dp0tools\echox.exe" -c 0A "<Developer Options>"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 2. Menu item " & "%~dp0tools\echox.exe" -n -c 0D "Google FRP Unlock" & "%~dp0tools\echox.exe" -c 07 ":"
"%~dp0tools\echox.exe" -c 08 "    in this case, the correct files are flashed, allowing you to remove Google Account Lock"
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Note:"
ECHO.
"%~dp0tools\echox.exe" -c 08 -w 91 -e "Reboot into EDL mode if any error occurs!!!"
ECHO.
call :Ask_Any_Key_Next
goto :Menu_Unlock
rem **************************************************** END Unlock Help **************************************************

rem ************************************************* Analis_Tool_Folders *************************************************
:Analis_Tools_Folder
if exist %~dp0tools\*.* (
if not exist %~dp0logs\*.* (md %~dp0logs)
if exist %~dp0logs\program.log del /f %~dp0logs\program.log
if not exist %~dp0tools\adb.exe (ECHO.ERROR: %~dp0tools\adb.exe - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\AdbWinApi.dll (ECHO.ERROR: %~dp0tools\AdbWinApi.dll - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\AdbWinUsbApi.dll (ECHO.ERROR: %~dp0tools\AdbWinUsbApi.dll - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\ConsoleNoClose.exe (ECHO.ERROR: %~dp0tools\ConsoleNoClose.exe - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\devcon.exe (ECHO.ERROR: %~dp0tools\devcon.exe - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\EchoX.exe (ECHO.ERROR: %~dp0tools\EchoX.exe - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\emmcdl.exe (ECHO.ERROR: %~dp0tools\emmcdl.exe - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\fastboot.exe (ECHO.ERROR: %~dp0tools\fastboot.exe - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\fh_loader.exe (ECHO.ERROR: %~dp0tools\fh_loader.exe - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\prog_ufs_firehose_sdm855.elf (ECHO.ERROR: %~dp0tools\prog_ufs_firehose_sdm855.elf - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\all.xml (ECHO.ERROR: %~dp0tools\all.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\full.xml (ECHO.ERROR: %~dp0tools\full.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\boot.xml (ECHO.ERROR: %~dp0tools\boot.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\modem.xml (ECHO.ERROR: %~dp0tools\modem.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\unlock.xml (ECHO.ERROR: %~dp0tools\unlock.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\frp_unlock.xml (ECHO.ERROR: %~dp0tools\frp_unlock.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0tools\reset.xml (ECHO.ERROR: %~dp0tools\reset.xml - not found !!!>>%~dp0logs\program.log)
) else (ECHO.ERROR: Folder %~dp0tools - not found !!!>>%~dp0logs\program.log)
call :Date_Time 
if exist %~dp0logs\program.log (ren %~dp0logs\program.log Program_%DTTM%.log & ECHO.!!! ERROR !!! not found important files for the program & ECHO.LOG-file: %~dp0logs\Program_%DTTM%.log & timeout /t 5 & Exit)
Exit /B

rem *********************************************** END Analis_Tool_Folders ***********************************************

rem **************************************************** Analis_Folders ***************************************************
:Analis_Folders
if not exist %~dp0logs\*.* (md %~dp0logs)
if not exist %~dp0flash\*.* (md %~dp0flash)
if not exist %~dp0backup\*.* (md %~dp0backup)
if not exist %~dp0unlock\*.* (md %~dp0unlock)
if not exist %~dp0flash\full\*.* (md %~dp0flash\full)
if not exist %~dp0flash\boot\*.* (md %~dp0flash\boot)
if not exist %~dp0flash\modem\*.* (md %~dp0flash\modem)
if not exist %~dp0backup\full\*.* (md %~dp0backup\full)
if not exist %~dp0backup\boot\*.* (md %~dp0backup\boot)
if not exist %~dp0backup\modem\*.* (md %~dp0backup\modem)
if not exist %~dp0backup\all\*.* (md %~dp0backup\all)
Exit /B
rem ************************************************** END Analis_Folders *************************************************


rem ***************************************************** Analis_Files ****************************************************
:Analis_Files
set ErrAnalisFiles=
if exist %~dp0logs\program.log del /f %~dp0logs\program.log 
if exist %~dp0tools\%~1.xml (
call :Check_Sparse_Files "%~dp0tools\%~1.xml" "%~dp0%~2"
call :Search_Files "%~dp0tools\%~1.xml" "%~dp0%~2"
) else (ECHO.ERROR: %~dp0tools\%~1.xml - not found !!!>>%~dp0logs\program.log)
call :Date_Time 
if exist %~dp0logs\program.log (ren %~dp0logs\program.log Program_%DTTM%.log & set ErrAnalisFiles=1)
if not defined ErrAnalisFiles Exit /B
"%~dp0tools\echox.exe" -c 0C "Error !!!"
ECHO.
ECHO.
call :Warning
ECHO.
ECHO.
call :Analis_Warning_%~3 "%~dp0%~2"
goto :%~3_HELP

:Analis_Files_FULL_EDL
set ErrAnalisFiles=
if exist %~dp0logs\program.log del /f %~dp0logs\program.log 
if exist %~dp0flash\full\rawprogram0.xml (
call :Check_Sparse_Files "%~dp0flash\full\rawprogram0.xml" "%~dp0flash\full"
call :Search_Files "%~dp0flash\full\rawprogram0.xml" "%~dp0flash\full"
) else (ECHO.ERROR: %~dp0flash\full\rawprogram0.xml - not found !!!>>%~dp0logs\program.log)
if exist %~dp0flash\full\rawprogram1.xml (
call :Check_Sparse_Files "%~dp0flash\full\rawprogram1.xml" "%~dp0flash\full"
call :Search_Files "%~dp0flash\full\rawprogram1.xml" "%~dp0flash\full"
) else (ECHO.ERROR: %~dp0flash\full\rawprogram1.xml - not found !!!>>%~dp0logs\program.log)
if exist %~dp0flash\full\rawprogram2.xml (
call :Check_Sparse_Files "%~dp0flash\full\rawprogram2.xml" "%~dp0flash\full"
call :Search_Files "%~dp0flash\full\rawprogram2.xml" "%~dp0flash\full"
) else (ECHO.ERROR: %~dp0flash\full\rawprogram2.xml - not found !!!>>%~dp0logs\program.log)
if exist %~dp0flash\full\rawprogram3.xml (
call :Check_Sparse_Files "%~dp0flash\full\rawprogram3.xml" "%~dp0flash\full"
call :Search_Files "%~dp0flash\full\rawprogram3.xml" "%~dp0flash\full"
) else (ECHO.ERROR: %~dp0flash\full\rawprogram3.xml - not found !!!>>%~dp0logs\program.log)
if exist %~dp0flash\full\rawprogram4.xml (
call :Check_Sparse_Files "%~dp0flash\full\rawprogram4.xml" "%~dp0flash\full"
call :Search_Files "%~dp0flash\full\rawprogram4.xml" "%~dp0flash\full"
) else (ECHO.ERROR: %~dp0flash\full\rawprogram4.xml - not found !!!>>%~dp0logs\program.log)
if exist %~dp0flash\full\rawprogram5.xml (
call :Check_Sparse_Files "%~dp0flash\full\rawprogram5.xml" "%~dp0flash\full"
call :Search_Files "%~dp0flash\full\rawprogram5.xml" "%~dp0flash\full"
) else (ECHO.ERROR: %~dp0flash\full\rawprogram5.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0flash\full\patch0.xml (ECHO.ERROR: %~dp0flash\full\patch0.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0flash\full\patch1.xml (ECHO.ERROR: %~dp0flash\full\patch1.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0flash\full\patch2.xml (ECHO.ERROR: %~dp0flash\full\patch2.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0flash\full\patch3.xml (ECHO.ERROR: %~dp0flash\full\patch3.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0flash\full\patch4.xml (ECHO.ERROR: %~dp0flash\full\patch4.xml - not found !!!>>%~dp0logs\program.log)
if not exist %~dp0flash\full\patch5.xml (ECHO.ERROR: %~dp0flash\full\patch5.xml - not found !!!>>%~dp0logs\program.log)
call :Date_Time 
if exist %~dp0logs\program.log (ren %~dp0logs\program.log Program_%DTTM%.log & set ErrAnalisFiles=1)
if not defined ErrAnalisFiles Exit /B
"%~dp0tools\echox.exe" -c 0C "Error !!!"
ECHO.
ECHO.
call :Warning
ECHO.
ECHO.
call :Analis_Warning_Flash "%~dp0flash\full"
goto :Flash_HELP


:Analis_Files_Backup
set backup_yes=
set backup=
if not exist %~dp0backup\%~1\Backup_Info.txt Exit /B
if exist %~dp0backup\%~1\Backup_Info.txt (for /f "delims=" %%a in (%~dp0backup\%~1\Backup_Info.txt) do (set backup=%%a))
"%~dp0tools\echox.exe" -c 0E "!!! Warning !!!"
"%~dp0tools\echox.exe" -n -c 0F "                      Previous backup detected: "
if defined backup ("%~dp0tools\echox.exe" -c 0D  "%backup%") else ("%~dp0tools\echox.exe" -c 0C  "!!! no data !!!")
set ErrAnalisFiles=
if exist %~dp0logs\program.log del /f %~dp0logs\program.log 
if exist %~dp0tools\%~1.xml (
call :Check_Sparse_Files "%~dp0tools\%~1.xml" "%~dp0%~2"
call :Search_Files "%~dp0tools\%~1.xml" "%~dp0%~2"
) else (ECHO.ERROR: %~dp0tools\%~1.xml - not found !!!>>%~dp0logs\program.log)
call :Date_Time 
if exist %~dp0logs\program.log (ren %~dp0logs\program.log Program_%DTTM%.log & set ErrAnalisFiles=1)
ECHO.
ECHO.
call :Warning
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
if not defined ErrAnalisFiles ("%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Previous backup detected !!!"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0D -w 91 -e "in folder: %~dp0%~2"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 0E "       !!! All backup data " & "%~dp0tools\echox.exe" -n -c 0D  "%backup%" & "%~dp0tools\echox.exe" -c 0E " will be lost !!!"
ECHO.
ECHO.
ECHO.
) else (
"%~dp0tools\echox.exe" -n -c 0A "             !!! Previous backup detected, " & "%~dp0tools\echox.exe" -n -c 0C "but there are no important files " & "%~dp0tools\echox.exe" -c 0A "!!!"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0D -w 91 -e "in folder: %~dp0%~2"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "!!! Please read the information in the LOG-file !!!"
ECHO.
"%~dp0tools\echox.exe" -n -c 08 "                         LOG-file: " & "%~dp0tools\echox.exe" -c 06 "Program_%DTTM%.log"
)
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Continue to backup, the previous backup will be replaced? Y - Yes, N - No"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
choice /C YN /N >nul
if /i %errorlevel% neq 1 goto :Backup_HELP
set backup_yes=1
Exit /B
rem *************************************************** END Analis_Files ***************************************************


rem ************************************************************************************************************************

:Find_Phone
set comport=
set phone_mode=
for /f  "skip=1 tokens=2 delims=(COM)" %%i in ('"%~dp0tools\devcon.exe" ^-resources ^=ports ^*PID_9008') do call :Find_Com_Number "%%i"
rem for /f  "tokens=2 delims=(COM)" %%i in ("Qualcomm HS-USB QDLoader 9008 (COM4)") do call :Find_Com_Number "%%i"
if defined comport (
reg add "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Ports" /v "COM%comport%:" /t REG_SZ /d 115200,n,8,1 /f >nul 2>nul
for /f  "skip=1 tokens=3" %%i in ('reg query "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Ports" /v "COM%comport%:"') do set comport_mode=%%i
set phone_mode=EDL
Exit /B)
for /f  "skip=1 tokens=4 delims=(COM)" %%i in ('"%~dp0tools\devcon.exe" ^-resources ^=ports ^*PID_0112') do call :Find_Com_Number "%%i"
if defined comport (
reg add "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Ports" /v "COM%comport%:" /t REG_SZ /d 115200,n,8,1 /f >nul 2>nul
for /f  "skip=1 tokens=3" %%i in ('reg query "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Ports" /v "COM%comport%:"') do set comport_mode=%%i
set phone_mode=DFU
Exit /B)
Exit /B

:Find_Com_Number
set y=%~1
set /a x=%~1
if %x%==%y% set comport=%x%
Exit /B

:Reboot_EDL
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Search ADB Interface:"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Search" & "%~dp0tools\echox.exe" -n -c 0F " >>> "
"%~dp0tools\devcon.exe" find * | findstr "ADB" >nul 2>&1
IF "%ERRORLEVEL%" equ "0" (for /f  "tokens=2 delims=:" %%i in ('"%~dp0tools\devcon.exe" find ^* ^| findstr ADB') do ("%~dp0tools\echox.exe" -n -c 0D "interface found" & "%~dp0tools\echox.exe" -n -c 0F " >>>" & "%~dp0tools\echox.exe" -c 0B "%%i")) else  ("%~dp0tools\echox.exe" -c 0C "!!! Error !!! ADB Interface not found" & call :No_ADB_Inteface)
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Checking ADB Interface:"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Command execution " & "%~dp0tools\echox.exe" -n -c 0A "adb devices" & "%~dp0tools\echox.exe" -n -c 0F " >>> "
"%~dp0tools\adb.exe" devices | findstr "\<device\>" >nul 2>&1
IF "%ERRORLEVEL%" equ "0" (for /f "skip=1" %%z in ('"%~dp0tools\adb.exe" devices') do ("%~dp0tools\echox.exe" -n -c 0D "answer received" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0B "phone is connected, number: %%z" & goto :Find_ADB))
"%~dp0tools\adb.exe" devices | findstr "recovery" >nul 2>&1
IF "%ERRORLEVEL%" equ "0" (for /f "skip=1" %%z in ('"%~dp0tools\adb.exe" devices') do ("%~dp0tools\echox.exe" -n -c 0D "answer received" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0B "phone is connected, number: %%z")) else  ("%~dp0tools\echox.exe" -c 0C "!!! Error !!! no answer from phone" & call :No_ADB_devices)
:Find_ADB
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Reboot the phone into EDL mode:"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " Command execution " & "%~dp0tools\echox.exe" -n -c 0A "adb reboot edl" & "%~dp0tools\echox.exe" -n -c 0F " >>> "
"%~dp0tools\adb.exe" reboot edl >nul 2>&1
"%~dp0tools\echox.exe" -n -c 0D "the command is executed" & "%~dp0tools\echox.exe" -n -c 0F " >>> " & "%~dp0tools\echox.exe" -c 0B "reboot"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Wait !!!"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
timeout /t 5 /NOBREAK >nul 2>nul
goto :Main_Screen
Exit /B

:No_ADB_Inteface
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0D -w 91 -e "Possible solutions to the problem:"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 1. Boot the phone to the system and allow " & "%~dp0tools\echox.exe" -n -c 0A "<USB Debugging>" & "%~dp0tools\echox.exe" -n -c 07 " in the menu " & "%~dp0tools\echox.exe" -c 0A "<Developer Options>"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 " 2. Boot the phone into the " & "%~dp0tools\echox.exe" -n -c 0A "FTM mode" & "%~dp0tools\echox.exe" -n -c 07 " through the key combination: " & "%~dp0tools\echox.exe" -c 0A "volume down + power"
ECHO.
ECHO.
ECHO.
call :Ask_Any_Key_Repeat
goto :Main_Screen
Exit /B

:No_ADB_devices
ECHO.
"%~dp0tools\echox.exe" -c 0D -w 91 -e "Possible solutions to the problem:"
ECHO.
"%~dp0tools\echox.exe" -c 07 -w 91 -e "On the screen of your phone there is a request for the system to allow debugging via USB,"
"%~dp0tools\echox.exe" -n -c 07 "                                confirm it - press " & "%~dp0tools\echox.exe" -c 0A "<Yes>"
ECHO.
call :Ask_Any_Key_Repeat
goto :Main_Screen
Exit /B

:Info_Show
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "Note:"
ECHO.
"%~dp0tools\echox.exe" -c 08 " 1. All the progress of the program will be recorded in the logs, in the logs folder"
"%~dp0tools\echox.exe" -c 08 " 2. Reboot into EDL mode if any error occurs!!!"
Exit /B

:Ask_Any_Key_Exit
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "To exit the program, press any key"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
pause>nul
Exit

:Ask_Any_Key_Next
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Press any key to continue"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
pause>nul
Exit /B

:Ask_Any_Key_Repeat
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0C -w 91 -e "To search the phone again, press any key"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
pause>nul
Exit /B

:Ask_Reboot
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Reboot your phone and end the program? Y - Yes, N - No"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
choice /C YN /N >nul
if /i %errorlevel% equ 1 call :Reboot
Exit /B

:Analis_Warning_Flash
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0C -w 91 -e "!!! Important files missing or detected SPARSE image !!!"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "in folder: %~1"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "!!! Please read the information in the LOG-file !!!"
ECHO.
"%~dp0tools\echox.exe" -n -c 08 "                         LOG-file: " & "%~dp0tools\echox.exe" -c 06 "Program_%DTTM%.log"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Press any key to continue"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
pause>nul
Exit/B

:Analis_Warning_Restore
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0C -w 91 -e "!!! Could not find backup or its important files !!!"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0D -w 91 -e "in folder: %~1"
ECHO.
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e "!!! Please read the information in the LOG-file !!!"
ECHO.
"%~dp0tools\echox.exe" -n -c 08 "                         LOG-file: " & "%~dp0tools\echox.exe" -c 06 "Program_%DTTM%.log"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Press any key to continue"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
pause>nul
Exit/B

:Bootloader_Unlock_Warning
CLS
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
call :Show_Bootloader_Unlock
ECHO.
call :Warning
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Carefully read this information !!!"
ECHO.
"%~dp0tools\echox.exe" -n -c 07 "    The unlock process is accompanied by the full formatting of the " & "%~dp0tools\echox.exe" -n -c 0D "userdata" & "%~dp0tools\echox.exe" -c 07 " partition"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "All data from the phone memory will be deleted (photos, music, videos, etc...)!!!"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -n -c 07 "               Before you start, make sure that you have allowed " & "%~dp0tools\echox.exe" -c 0A "<Unlock OEM>" 
"%~dp0tools\echox.exe" -n -c 07 "                    and " & "%~dp0tools\echox.exe" -n -c 0A "<USB Debugging>" & "%~dp0tools\echox.exe" -n -c 07 " in the menu " & "%~dp0tools\echox.exe" -c 0A "<Developer options>"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0E -w 91 -e " After flashing this file the program will start the process of automatic bootloader unlock"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 0A -w 91 -e "!!! Read the messages on the computer and phone screen carefully !!!"
ECHO.
ECHO.
"%~dp0tools\echox.exe" -c 03 "==========================================================================================="
"%~dp0tools\echox.exe" -c 0F -w 91 -e "Continue? All data from the phone will be deleted !!! Y - Yes, N - No"
"%~dp0tools\echox.exe" -n -c 03 "==========================================================================================="
choice /C YN /N >nul
if /i %errorlevel% equ 1 call :Unlock "Bootloader Unlock" "unlock"
goto :Menu_Unlock
Exit /B

:Port_Show
if not defined comport goto :Port_Show_Not_Active
"%~dp0tools\echox.exe" -n -c 03 " Port: " & "%~dp0tools\echox.exe" -c 06 "COM%comport%"
if "%phone_mode%" equ "EDL" ("%~dp0tools\echox.exe" -n -c 03 " Name: " & "%~dp0tools\echox.exe" -c 06 "Qualcomm HS-USB QDLoader 9008")
if "%phone_mode%" equ "DFU" ("%~dp0tools\echox.exe" -n -c 03 " Name: " & "%~dp0tools\echox.exe" -c 06 "ZTE Handset Diagnostic Interface(DFU)") 
"%~dp0tools\echox.exe" -n -c 03 " Settings: " & "%~dp0tools\echox.exe" -c 06 "%comport_mode%"
"%~dp0tools\echox.exe" -n -c 03 " Mode: " & "%~dp0tools\echox.exe" -c 06 "%phone_mode%" 
Exit /B

:Port_Show_Not_Active
"%~dp0tools\echox.exe" -n -c 03 " Port: " & "%~dp0tools\echox.exe" -c 04 "no data"
"%~dp0tools\echox.exe" -n -c 03 " Name: " & "%~dp0tools\echox.exe" -c 04 "no data"
"%~dp0tools\echox.exe" -n -c 03 " Settings: " & "%~dp0tools\echox.exe" -c 04 "no data"
"%~dp0tools\echox.exe" -n -c 03 " Mode: " & "%~dp0tools\echox.exe" -c 04 "no data"
Exit /B

:Date_Time
if /i %time:~0,2% LSS 10 (set DTTM=%date:~0,2%-%date:~3,2%-%date:~6,4%_0%time:~1,1%-%time:~3,2%-%time:~6,2%) else (set DTTM=%date:~0,2%-%date:~3,2%-%date:~6,4%_%time:~0,2%-%time:~3,2%-%time:~6,2%)
Exit/B

:Warning
"%~dp0tools\echox.exe" -c 0C -w 91 -e "                         (_)            "            
"%~dp0tools\echox.exe" -c 0C -w 91 -e "__      ____ _ _ __ _ __  _ _ __   __ _ "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "\ \ /\ / / _` | '__| '_ \| | '_ \ / _` |"
"%~dp0tools\echox.exe" -c 0C -w 91 -e " \ V  V / (_| | |  | | | | | | | | (_| |"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "  \_/\_/ \__,_|_|  |_| |_|_|_| |_|\__, |"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "                                   __/ |"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "                                  |___/ " 
Exit/b

:Success
"%~dp0tools\echox.exe" -c 0A -w 91 -e " ____                              "                              
"%~dp0tools\echox.exe" -c 0A -w 91 -e "/ ___| _   _  ___ ___ ___  ___ ___ "
"%~dp0tools\echox.exe" -c 0A -w 91 -e "\___ \| | | |/ __/ __/ _ \/ __/ __|"
"%~dp0tools\echox.exe" -c 0A -w 91 -e " ___) | |_| | (_| (_|  __/\__ \__ \"
"%~dp0tools\echox.exe" -c 0A -w 91 -e "|____/ \__,_|\___\___\___||___/___/"
Exit/b                                    

:Failure
"%~dp0tools\echox.exe" -c 0C -w 91 -e " _____     _ _                "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|  ___|_ _(_) |_   _ _ __ ___ "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "| |_ / _` | | | | | | '__/ _ \"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|  _| (_| | | | |_| | | |  __/"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|_|  \__,_|_|_|\__,_|_|  \___|"
Exit/b  

:Phone_Search
"%~dp0tools\echox.exe" -c 0C -w 91 -e " ____  _                           ____                      _     "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|  _ \| |__   ___  _ __   ___     / ___|  ___  __ _ _ __ ___| |__  "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "| |_) | '_ \ / _ \| '_ \ / _ \    \___ \ / _ \/ _` | '__/ __| '_ \ "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|  __/| | | | (_) | | | |  __/     ___) |  __/ (_| | | | (__| | | |"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|_|   |_| |_|\___/|_| |_|\___|    |____/ \___|\__,_|_|  \___|_| |_|"                                                                 
Exit/b 

:Phone_DFU
"%~dp0tools\echox.exe" -c 0C -w 91 -e " ____  _                         _          ____  _____ _   _    __  __           _      "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|  _ \| |__   ___  _ __   ___   (_)_ __    |  _ \|  ___| | | |  |  \/  | ___   __| | ___ "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "| |_) | '_ \ / _ \| '_ \ / _ \  | | '_ \   | | | | |_  | | | |  | |\/| |/ _ \ / _` |/ _ \"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|  __/| | | | (_) | | | |  __/  | | | | |  | |_| |  _| | |_| |  | |  | | (_) | (_| |  __/"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|_|   |_| |_|\___/|_| |_|\___|  |_|_| |_|  |____/|_|    \___/   |_|  |_|\___/ \__,_|\___|"                                                             
Exit/b 


:Show_Main_Menu
"%~dp0tools\echox.exe" -c 0A -w 91 -e " __  __       _            __  __                  "
"%~dp0tools\echox.exe" -c 0A -w 91 -e "|  \/  | __ _(_)_ __      |  \/  | ___ _ __  _   _ "
"%~dp0tools\echox.exe" -c 0A -w 91 -e "| |\/| |/ _` | | '_ \     | |\/| |/ _ \ '_ \| | | |"
"%~dp0tools\echox.exe" -c 0A -w 91 -e "| |  | | (_| | | | | |    | |  | |  __/ | | | |_| |"
"%~dp0tools\echox.exe" -c 0A -w 91 -e "|_|  |_|\__,_|_|_| |_|    |_|  |_|\___|_| |_|\__,_|"
Exit/b                                           

:Show_Flash_Menu
"%~dp0tools\echox.exe" -c 0A -w 91 -e " _____ _           _     "
"%~dp0tools\echox.exe" -c 0A -w 91 -e "|  ___| | __ _ ___| |__  "
"%~dp0tools\echox.exe" -c 0A -w 91 -e "| |_  | |/ _` / __| '_ \ "
"%~dp0tools\echox.exe" -c 0A -w 91 -e "|  _| | | (_| \__ \ | | |"
"%~dp0tools\echox.exe" -c 0A -w 91 -e "|_|   |_|\__,_|___/_| |_|"
Exit/b

:Show_Backup_Menu
"%~dp0tools\echox.exe" -c 0E -w 91 -e " ____             _                "
"%~dp0tools\echox.exe" -c 0E -w 91 -e "| __ )  __ _  ___| | ___   _ _ __  "
"%~dp0tools\echox.exe" -c 0E -w 91 -e "|  _ \ / _` |/ __| |/ / | | | '_ \ "
"%~dp0tools\echox.exe" -c 0E -w 91 -e "| |_) | (_| | (__|   <| |_| | |_) |"
"%~dp0tools\echox.exe" -c 0E -w 91 -e "|____/ \__,_|\___|_|\_\\__,_| .__/ "
"%~dp0tools\echox.exe" -c 0E -w 91 -e "                            |_|    "						  
Exit/b

:Show_Restore_Menu			  
"%~dp0tools\echox.exe" -c 0D -w 91 -e " ____           _                 "
"%~dp0tools\echox.exe" -c 0D -w 91 -e "|  _ \ ___  ___| |_ ___  _ __ ___ "
"%~dp0tools\echox.exe" -c 0D -w 91 -e "| |_) / _ \/ __| __/ _ \| '__/ _ \"
"%~dp0tools\echox.exe" -c 0D -w 91 -e "|  _ <  __/\__ \ || (_) | | |  __/"
"%~dp0tools\echox.exe" -c 0D -w 91 -e "|_| \_\___||___/\__\___/|_|  \___|"
Exit/b                                   						  

:Show_Unlock_Menu
"%~dp0tools\echox.exe" -c 0C -w 91 -e " _   _       _            _    "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "| | | |_ __ | | ___   ___| | __"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "| | | | '_ \| |/ _ \ / __| |/ /"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "| |_| | | | | | (_) | (__|   < "
"%~dp0tools\echox.exe" -c 0C -w 91 -e " \___/|_| |_|_|\___/ \___|_|\_\"
Exit/b                                														  

:Show_Bootloader_Unlock
"%~dp0tools\echox.exe" -c 0C -w 91 -e " ____              _   _                 _             _   _       _            _    "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "| __ )  ___   ___ | |_| | ___   __ _  __| | ___ _ __  | | | |_ __ | | ___   ___| | __"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|  _ \ / _ \ / _ \| __| |/ _ \ / _` |/ _` |/ _ \ '__| | | | | '_ \| |/ _ \ / __| |/ /"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "| |_) | (_) | (_) | |_| | (_) | (_| | (_| |  __/ |    | |_| | | | | | (_) | (__|   < "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "|____/ \___/ \___/ \__|_|\___/ \__,_|\__,_|\___|_|     \___/|_| |_|_|\___/ \___|_|\_\"
Exit/b     

:Show_Automatic
"%~dp0tools\echox.exe" -c 0C -w 91 -e "    _         _                        _   _        _   _       _            _    "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "   / \  _   _| |_ ___  _ __ ___   __ _| |_(_) ___  | | | |_ __ | | ___   ___| | __"
"%~dp0tools\echox.exe" -c 0C -w 91 -e "  / _ \| | | | __/ _ \| '_ ` _ \ / _` | __| |/ __| | | | | '_ \| |/ _ \ / __| |/ /"
"%~dp0tools\echox.exe" -c 0C -w 91 -e " / ___ \ |_| | || (_) | | | | | | (_| | |_| | (__  | |_| | | | | | (_) | (__|   < "
"%~dp0tools\echox.exe" -c 0C -w 91 -e "/_/   \_\__,_|\__\___/|_| |_| |_|\__,_|\__|_|\___|  \___/|_| |_|_|\___/ \___|_|\_\"                                                                                
Exit/b

:Show_Unlocked
"%~dp0tools\echox.exe" -c 0A -w 91 -e " _   _       _            _            _ "
"%~dp0tools\echox.exe" -c 0A -w 91 -e "| | | |_ __ | | ___   ___| | _____  __| |"
"%~dp0tools\echox.exe" -c 0A -w 91 -e "| | | | '_ \| |/ _ \ / __| |/ / _ \/ _` |"
"%~dp0tools\echox.exe" -c 0A -w 91 -e "| |_| | | | | | (_) | (__|   <  __/ (_| |"
"%~dp0tools\echox.exe" -c 0A -w 91 -e " \___/|_| |_|_|\___/ \___|_|\_\___|\__,_|"
Exit/b                                          


:Check_Sparse_Files
for /f "tokens=4" %%a in ('findstr "sparse\=\"true\"" %~1') do (
for /f delims^=^"^ tokens^=2 %%i in ("%%a") do (if exist %~2\%%i ECHO.ERROR: %~2\%%i - SPARSE image!!!>>%~dp0logs\program.log))
Exit/b

:Search_Files
for /f "tokens=4" %%a in (%~1) do (
for /f delims^=^"^ tokens^=2 %%i in ("%%a") do (if not exist %~2\%%i ECHO.Warning: %~2\%%i - not found !!!>>%~dp0logs\program.log))
Exit/b

:LOG_Backup_Part_Files
for /f "tokens=4" %%a in (%~dp0tools\%~1.xml) do (
for /f delims^=^"^ tokens^=2 %%i in ("%%a") do (ECHO.Backup: %~dp0backup\%~1\%%i>>%~dp0backup\%~1\Backup_Files.log))
>>"%~dp0backup\%~1\Backup.log" (
for /f "usebackq delims=" %%i in ("%~dp0backup\%~1\Backup_Files.log") do @(
 set/a m+=1,n=0
 for /f "tokens=2 usebackq delims=^'" %%j in ("%~dp0backup\%~1\DigestsPerFile.txt") do @(
  set/a n+=1
  2>nul set/a 1/(m-n^)|| echo %%i%%j
 )
)
) 
Exit/b

:Show_Flash_Part
Setlocal EnableDelayedExpansion
for /l %%c in (0,1,5) do (
if %~2 equ 5 (Call :Find_Flash_Part "%~dp0%~1%%c.xml" "!part_lun%%c!" "%%c") else (Call :Find_Flash_Part "%~dp0%~1.xml" "!part_lun%%c!" "%%c"))
Setlocal DisableDelayedExpansion
Exit/B

:Find_Flash_Part
Setlocal EnableDelayedExpansion
"%~dp0tools\echox.exe" -n -c 0D "      LUN%~3:    "
for %%p in (%~2) do (
for /f delims^=^\^"^ tokens^=1 %%n in ("%%p") do (set name_part=%%n)
for /f "tokens=4,5,8" %%a in ('findstr "%%p" %~1') do (
for /f delims^=^"^ tokens^=2 %%y in ("%%a") do (set flash_part=1)
for /f delims^=^"^ tokens^=2 %%z in ("%%c") do (set /a num_part=%%z)
for /f delims^=^"^ tokens^=2 %%x in ("%%b") do (
set new_part=%%x
if "!new_part!" neq "!old_part!" (
if "!num_part!" == "%~3" (
set old_part=!new_part!
set find_part=1
set /a column = column + 1
if defined flash_part ("%~dp0tools\echox.exe" -n -c 0A -w 11 "%%x " & "%~dp0tools\echox.exe" -n -c 0E "    ") else ("%~dp0tools\echox.exe" -n -c 08 -w 11 "%%x " & "%~dp0tools\echox.exe" -n -c 0E "    ")
if !column! equ 5 ("%~dp0tools\echox.exe" -c 0E "" & "%~dp0tools\echox.exe" -n -c 0E "               " & set column=))))
set flash_part=
)
if not defined find_part (
"%~dp0tools\echox.exe" -n -c 08 -w 11 "!name_part! " & "%~dp0tools\echox.exe" -n -c 0E "    "
set /a column = column + 1
if !column! equ 5 ("%~dp0tools\echox.exe" -c 0E "" & "%~dp0tools\echox.exe" -n -c 0E "               " & set column=))
set find_part=
)
"%~dp0tools\echox.exe" -c 0E "" 
Setlocal DisableDelayedExpansion
Exit /B

rem ******************************************************************************************************************************
